/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Evaluation
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 20.02.2007
Author  : Freeware, for evaluation and non-commercial use only
Company : 
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega16


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// 1 Wire Bus functions
#asm
   .equ __w1_port=0x15 ;PORTC
   .equ __w1_bit=4
#endasm
/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for Dallas Semiconductor
  1 Wire protocol functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE 1 WIRE BUS IS CONNECTED AND
  THE DATA BIT USED

  EXAMPLE FOR PORTB:

    #asm
        .equ __w1_port=0x18
        .equ __w1_bit=3
    #endasm
    #include <1wire.h>
*/


#pragma used+
unsigned char w1_init(void);
unsigned char w1_read(void);
unsigned char w1_write(unsigned char data);
unsigned char w1_search(unsigned char cmd,void *p);
unsigned char w1_dow_crc8(void *p,unsigned char n);
#pragma used-



// DS1820 Temperature Sensor functions
/*
  CodeVisionAVR C Compiler
  (C) 1998-2005 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for Dallas Semiconductor
  DS18B20 1 Wire bus temperature sensor
  functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE 1 WIRE BUS IS CONNECTED AND
  THE DATA BIT USED

  EXAMPLE FOR PORTB:

    #asm
        .equ __w1_port=0x18
        .equ __w1_bit=3
    #endasm
    #include <ds1820.h>
*/


/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for Dallas Semiconductor
  1 Wire protocol functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE 1 WIRE BUS IS CONNECTED AND
  THE DATA BIT USED

  EXAMPLE FOR PORTB:

    #asm
        .equ __w1_port=0x18
        .equ __w1_bit=3
    #endasm
    #include <1wire.h>
*/







#pragma used+
extern struct __ds18b20_scratch_pad_struct
       {
       unsigned char temp_lsb,temp_msb,
                temp_high,temp_low,
                conf_register,
                res1,
                res2,
                res3,
                crc;
       } __ds18b20_scratch_pad;

unsigned char ds18b20_select(unsigned char *addr);
unsigned char ds18b20_read_spd(unsigned char *addr);
float ds18b20_temperature(unsigned char *addr);
unsigned char ds18b20_init(unsigned char *addr,signed char temp_low,signed char temp_high,
unsigned char resolution);
#pragma used-

#pragma library ds18b20.lib


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib



/* maximum number of DS1820/DS18S20 connected to the 1 Wire bus */

/* DS1820/DS18S20 devices ROM code storage area */
unsigned char rom_code[8][9];


signed char sec_counter = 0;
signed char led_status=0xfe; 
signed char LED = 3;
char STATE = 0;
int btn_1 = 0;
int btn_2 = 0; 
int Temper1;  
unsigned char devices;
//------------------------------------------------------------------------------
char Cifri[10]={
//hgfedcba   hgfedcba
  0b00111111,0b00000110,	//0,1
  0b01011011,0b01001111,	//2,3
  0b01100110,0b01101101,	//4,5
  0b01111101,0b00000111,	//6,7
  0b01111111,0b01101111		//8,9
};
//------------------------------------------------------------------------------
int Tempget(void)
{
//unsigned char devices;
int tempq;
//devices=w1_search(0xf0,rom_code); 
if(devices) 
{
   tempq=ceil(ds18b20_temperature(&rom_code[0][0]));  
}else
{
   tempq = 99 ;
}
return tempq;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void DrawInt(signed int i, char _state)
{
 
 if(i > 99) i = 99;
 if(i < 0) i = 00;
 PORTA = 0b00000000;
 PORTA = 0b00000000;
 if(_state == 0){
   PORTD = 0b00000010 ;
   PORTA = Cifri[i/10];
 }else{
   PORTD = 0b00000001;
   PORTA = Cifri[i%10];
 }
}
//------------------------------------------------------------------------------
void NextLED(void)
{
led_status<<=1;
led_status|=1;
LED++;
if (LED > 3){
    led_status=0xfe;
    LED = 0;
}
// turn on the LED
PORTD = 0b00000011;
Temper1 = Tempget();
PORTB=led_status;
}
//------------------------------------------------------------------------------
void PrewLED(void)
{
led_status>>=1;
led_status|=1;
LED--;
if (LED < 0){
    led_status=0xfe;
    LED = 3;
}
// turn on the LED 
PORTD = 0b00000011;
Temper1 = Tempget();
PORTB=led_status;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void port_init(void)
{
 PORTA = 0xFF;
 DDRA  = 0xFF;
 PORTB = 0xFF;
 DDRB  = 0xFF;
 PORTC = 0x3C; //m103 output only
 DDRC  = 0x00;
 PORTD = 0xE3;
 DDRD  = 0x03;
}

//TIMER1 initialize - prescale:64
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 1Sec
// actual value:  1,000Sec (0,0%)
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0x0B; //setup
 TCNT1L = 0xDC;
 OCR1AH = 0xF4;
 OCR1AL = 0x24;
 OCR1BH = 0xF4;
 OCR1BL = 0x24;
 ICR1H  = 0xF4;
 ICR1L  = 0x24;
 TCCR1A = 0x00;
 TCCR1B = 0x03; //start Timer
}

interrupt [9] void timer1_ovf_isr(void)
{
 
  //TIMER1 has overflowed
 TCNT1H = 0x0B; //reload counter high value
 TCNT1L = 0xDC; //reload counter low value

 sec_counter ++;
 if(sec_counter >= 10) 
 {
   NextLED();
   sec_counter = 0;
   Temper1 = Tempget();
 }
}
//TIMER2 initialize - prescale:32
// WGM: Normal
// desired value: 1mSec
// actual value:  1,000mSec (0,0%)
void timer2_init(void)
{
 TCCR2 = 0x00; //stop
 ASSR  = 0x00; //set async mode
 TCNT2 = 0xB2; //setup
 OCR2  = 0x4E;
 TCCR2 = 0x07; //start
}

// Timer 2 overflow interrupt service routine
interrupt [5] void timer2_ovf_isr(void)
{
    STATE = !STATE;
    DrawInt(Temper1, STATE);
 //---------------------------------------------  
  if ((PINC & 0b00000010) == 0){
  	 btn_1 ++;
  }else{
  	 btn_1 = 0;  
  }
  
  if(btn_1 == 1){
  		 sec_counter = -20;//30  (20+10)
		 NextLED();
  }
//---------------------------------------------  
  if ((PINC & 0b00000001) == 0){
  	 btn_2 ++;
  }else{
  	 btn_2 = 0;  
  }
  
  if(btn_2 == 1){
  		 sec_counter = -20;//30  (20+10)
		 PrewLED();
  } 
 

 TCNT2 = 0xB2; //reload counter value
}
//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up

 sec_counter = 0;
 LED = 3;
 STATE = 0;
 btn_1 = 0;
 btn_2 = 0;

 port_init();

// Temper1 = GetTemp();

 timer1_init();
 timer2_init();

 MCUCR = 0x00;
 GICR  = 0x00;
 TIMSK = 0x45; //timer interrupt sources

 led_status=0xfe;
 PORTA = 0b00000000;
 PORTD = 0b00000000;
 PORTB = led_status;
 
 w1_init();

 devices=w1_search(0xf0,rom_code);  

 NextLED();

 //all peripherals are now initialized
}


// Declare your global variables here


void main(void)
{
init_devices();

// Global enable interrupts
#asm("sei")


     
while (1){ 
/*
#asm("cli")
Temper1 = Tempget();
#asm("sei")
*/
/*
    delay_ms(10);
    STATE = !STATE;
    DrawInt(Temper1, STATE); 
*/
};

}
