/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.3 Evaluation
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 20.02.2007
Author  : Freeware, for evaluation and non-commercial use only
Company :
Comments:


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
#include <delay.h>

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x15 ;PORTC
   .equ __w1_bit=4
#endasm
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds18b20.h>
#include <stdio.h>
#include <math.h>

/* maximum number of DS1820/DS18S20 connected to the 1 Wire bus */
#define MAX_DEVICES 8

/* DS1820/DS18S20 devices ROM code storage area */
unsigned char rom_code[MAX_DEVICES][9];


signed char sec_counter = 0;
signed char led_status=0xfe;
signed char LED = 3;
char STATE = 0;
int btn_1 = 0;
int btn_2 = 0;
int Temper1;
unsigned char devices;
//------------------------------------------------------------------------------
char Cifri[10]={
//hgfedcba   hgfedcba
  0b00111111,0b00000110,	//0,1
  0b01011011,0b01001111,	//2,3
  0b01100110,0b01101101,	//4,5
  0b01111101,0b00000111,	//6,7
  0b01111111,0b01101111		//8,9
};
//------------------------------------------------------------------------------
int Tempget(void)
{
//unsigned char devices;
int tempq;
//devices=w1_search(0xf0,rom_code);
if(devices)
{
   tempq=ceil(ds18b20_temperature(&rom_code[0][0]));
}else
{
   tempq = 99 ;
}
return tempq;
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void DrawInt(signed int i, char _state)
{

 if(i > 99) i = 99;
 if(i < 0) i = 00;
 PORTA = 0b00000000;
 PORTA = 0b00000000;
 if(_state == 0){
   PORTD = 0b00000010 ;
   PORTA = Cifri[i/10];
 }else{
   PORTD = 0b00000001;
   PORTA = Cifri[i%10];
 }
}
//------------------------------------------------------------------------------
void NextLED(void)
{
led_status<<=1;
led_status|=1;
LED++;
if (LED > 3){
    led_status=0xfe;
    LED = 0;
}
// turn on the LED
PORTD = 0b00000011;
Temper1 = Tempget();
PORTB=led_status;
}
//------------------------------------------------------------------------------
void PrewLED(void)
{
led_status>>=1;
led_status|=1;
LED--;
if (LED < 0){
    led_status=0xfe;
    LED = 3;
}
// turn on the LED
PORTD = 0b00000011;
Temper1 = Tempget();
PORTB=led_status;
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
void port_init(void)
{
 PORTA = 0xFF;
 DDRA  = 0xFF;
 PORTB = 0xFF;
 DDRB  = 0xFF;
 PORTC = 0x3C; //m103 output only
 DDRC  = 0x00;
 PORTD = 0xE3;
 DDRD  = 0x03;
}

//TIMER1 initialize - prescale:64
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 1Sec
// actual value:  1,000Sec (0,0%)
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0x0B; //setup
 TCNT1L = 0xDC;
 OCR1AH = 0xF4;
 OCR1AL = 0x24;
 OCR1BH = 0xF4;
 OCR1BL = 0x24;
 ICR1H  = 0xF4;
 ICR1L  = 0x24;
 TCCR1A = 0x00;
 TCCR1B = 0x03; //start Timer
}

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{

  //TIMER1 has overflowed
 TCNT1H = 0x0B; //reload counter high value
 TCNT1L = 0xDC; //reload counter low value

 sec_counter ++;
 if(sec_counter >= 10)
 {
   NextLED();
   sec_counter = 0;
   Temper1 = Tempget();
 }
}
//TIMER2 initialize - prescale:32
// WGM: Normal
// desired value: 1mSec
// actual value:  1,000mSec (0,0%)
void timer2_init(void)
{
 TCCR2 = 0x00; //stop
 ASSR  = 0x00; //set async mode
 TCNT2 = 0xB2; //setup
 OCR2  = 0x4E;
 TCCR2 = 0x07; //start
}

// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
    STATE = !STATE;
    DrawInt(Temper1, STATE);
 //---------------------------------------------
  if ((PINC & 0b00000010) == 0){
  	 btn_1 ++;
  }else{
  	 btn_1 = 0;
  }

  if(btn_1 == 1){
  		 sec_counter = -20;//30  (20+10)
		 NextLED();
  }
//---------------------------------------------
  if ((PINC & 0b00000001) == 0){
  	 btn_2 ++;
  }else{
  	 btn_2 = 0;
  }

  if(btn_2 == 1){
  		 sec_counter = -20;//30  (20+10)
		 PrewLED();
  }


 TCNT2 = 0xB2; //reload counter value
}
//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up

 sec_counter = 0;
 LED = 3;
 STATE = 0;
 btn_1 = 0;
 btn_2 = 0;

 port_init();

// Temper1 = GetTemp();

 timer1_init();
 timer2_init();

 MCUCR = 0x00;
 GICR  = 0x00;
 TIMSK = 0x45; //timer interrupt sources

 led_status=0xfe;
 PORTA = 0b00000000;
 PORTD = 0b00000000;
 PORTB = led_status;

 w1_init();

 devices=w1_search(0xf0,rom_code);

 NextLED();

 //all peripherals are now initialized
}


// Declare your global variables here


void main(void)
{
init_devices();

// Global enable interrupts
#asm("sei")



while (1){
/*
#asm("cli")
Temper1 = Tempget();
#asm("sei")
*/
/*
    delay_ms(10);
    STATE = !STATE;
    DrawInt(Temper1, STATE);
*/
};

}
